<script setup xmlns="http://www.w3.org/1999/html">
import {Html5Qrcode} from "html5-qrcode";
import {onUnmounted, ref} from "vue";
import {genericError, myAlert, verifyQrCode} from "@/common/ServerAPI.js";

const paused = ref(false);
const accepted = ref(false);
const rejected = ref(false);
const response = ref(null);

function colorName(color) {
  switch (color) {
    case "red": return "rouge";
    case "green": return "vert";
    case "yellow": return "jaune";
    case "blue": return "bleu";
    case "orange": return "orange";
    case "purple": return "violet";
  }
}

let scanner = null;

function onScanSuccess(decodedText) {
  if (paused.value || !decodedText.match("^qr-[0-9]*$")) {
    return;
  }
  paused.value = true;
  scanner.pause(true);
  verifyQrCode(decodedText, responseText => {
    if (responseText === "NOT FOUND") {
      rejected.value = true;
    } else if (responseText === "FAILURE") {
      genericError();
    } else {
      accepted.value = true;
      response.value = JSON.parse(responseText);
    }
  });
}

const cameras = ref(null);
const started = ref(false);

function loadCams() {
  Html5Qrcode.getCameras().then(value => {
    cameras.value = value;
  }, reason => {
    myAlert(reason);
  })
}

function selectCam(cameraId) {
  scanner = new Html5Qrcode("reader");
  scanner.start(cameraId,
      {fps: 10, aspectRatio: 1},
      onScanSuccess, undefined)
      .then(() => {
        started.value = true;
      }).catch((err) => {
    myAlert(err);
  });
}

function resume() {
  accepted.value = false;
  rejected.value = false;
  paused.value = false;
  response.value = null;
  scanner.resume();
}

onUnmounted(() => {
  scanner.stop();
})
</script>

<template>
  <ul v-if="!started"
      class="flex flex-col text-center text-sm font-medium text-white mb-4 md:mt-20">
    <li class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-12">
      Verificateur des codes QR
    </li>
    <li v-if="cameras == null">
      <button
          @click="loadCams()"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        Commencer
      </button>
    </li>

    <li v-if="cameras != null" class="text-white">Sélectionnez la camera :</li>
    <li v-for="camera in cameras">
      <button
          @click="selectCam(camera.id)"
          class="mb-4 items-center px-4 py-3 font-bold text-black bg-s4s-redwood-700 rounded-lg active w-full lg:max-w-[30%] flex-center">
        {{ camera.label }}
      </button>
    </li>
  </ul>

  <div id="reader" :style="paused ? 'visibility: hidden' : 'visibility:visible'" ref="reader"></div>
  <div
      :style="paused ? 'visibility: visible' : 'visibility:hidden'"
      style="width: 100%; left: 50%; top: 50%; transform: translate(-50%, -50%);"
      class="absolute text-6xl p-0 m-0 text-center">
    <div v-if="paused && !accepted && !rejected">
      <span class="text-white">Vérification</span>
      <br>
      <div class="loader"></div>
    </div>

    <div v-if="paused && accepted && !rejected && response.accessCount === 0">
      <span class="text-white">Vérifié</span>
      <br>
      <div style="width: 75px; display: inline-grid; aspect-ratio: 1">✅</div>
      <br>
      <span style="color: red" class="text-2xl">{{ response.specialNotes }}<br></span>
      <span :style="'color:'+response.bandColor "
            class="text-2xl">Couleur du bracelet: {{ colorName(response.bandColor) }}<br></span>
      <span style="color: white" class="text-2xl">Salle d'accueil: {{ response.welcomeRoom }}<br></span>
    </div>

    <div v-if="paused && accepted && !rejected && response.accessCount !== 0">
      <span style="color: red">Refusé</span>
      <br>
      <div style="width: 75px; display: inline-grid; aspect-ratio: 1">❌</div>
      <br>
      <span style="color: red" class="text-2xl">Ce code a déjà été utilisé {{ response.accessCount }} fois!<br></span>
      <span style="color: red"
            class="text-2xl">Dernier accès le {{ new Date(parseInt(response.lastAccess)).toLocaleString() }}<br></span>
      <span style="color: red" class="text-2xl">{{ response.specialNotes }}<br></span>
      <span :style="'color:'+response.bandColor "
            class="text-2xl">Couleur du bracelet: {{ colorName(response.bandColor) }}<br></span>
      <span style="color: white" class="text-2xl">Salle d'accueil: {{ response.welcomeRoom }}<br></span>
    </div>

    <div v-if="paused && !accepted && rejected">
      <span style="color: red">Refusé</span>
      <br>
      <div style="width: 75px; display: inline-grid; aspect-ratio: 1">❌</div>
      <br>
      <span style="color: red" class="text-2xl">Ce code n'est pas un code d'accès S4S !<br></span>
    </div>

    <div v-if="paused && (accepted || rejected)">
      <button
          @click="resume()"
          class="mb-4 pl-10 pr-10 items-center px-4 py-3 text-2xl font-bold text-black bg-s4s-redwood-700 rounded-lg active lg:max-w-[30%] flex-center">
        Continuer →
      </button>
    </div>
  </div>
</template>

<style scoped>
.loader {
  width: 75px;
  aspect-ratio: 1;
  display: inline-grid;
}

.loader::before,
.loader::after {
  content: "";
  grid-area: 1/1;
  --c: no-repeat radial-gradient(farthest-side, #d3a589 92%, #0000);
  background: var(--c) 50% 0,
  var(--c) 50% 100%,
  var(--c) 100% 50%,
  var(--c) 0 50%;
  background-size: 20px 20px;
  animation: l12 1s infinite;
}

.loader::before {
  margin: 4px;
  filter: hue-rotate(45deg);
  background-size: 12px 12px;
  animation-timing-function: linear
}

@keyframes l12 {
  100% {
    transform: rotate(.5turn)
  }
}
</style>
